
--	StinkyQueue Initial Variables
local StinkyQueue_PartyMembers = {};
local StinkyQueue_SelfData = {};
local StinkyQueue_PartyRaidCount = 0;
local StinkyQueue_RaidIndexTable = {};
local StinkyQueue_GameIndex = {"AV","AB","WSG","AA","","ERROR!"};
local StinkyQueue_IndexGame = {["AV"]=1,["AB"]=2,["WSG"]=3,["AA"]=4,[""]=5};
local StinkyQueue_GameName = {["Alterac Valley"] = 1, ["Arathi Basin"] = 2, ["Warsong Gulch"] =3, ["All Arenas"] = 4, [""]=5};
local StinkyQueue_NameGame = {"Alterac Valley", "Arathi Basin", "Warsong Gulch", "All Arenas", ""};
local StinkyQueue_IsNotReadyList = {};
local StinkyQueue_Version = "2.00.02b";
local SQ_debugMode = false;
--
--	StinkyQueue On__ (or do once) functions
--

function StinkyQueue_OnLoad()
	this:RegisterEvent("CHAT_MSG_ADDON");
	this:RegisterEvent("BATTLEFIELDS_SHOW");
	this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("ADDON_LOADED");
	if (StinkyQueue_Options == nil) then
		StinkyQueue_VarsInit();
	end
end

function StinkyQueue_OnEvent()
	SQ_Debug(event,false);
	if (event == "UPDATE_BATTLEFIELD_STATUS") then
		local Send_bgStatus = "";
		local Send_bgName = ""; 
		local Send_bgID = "";
		for i=1, MAX_BATTLEFIELD_QUEUES, 1 do
			local bgStatus, bgName, bgID = GetBattlefieldStatus(i);
			if (bgName~=nil and bgStatus ~= "none") then
				Send_bgStatus = bgStatus;
				Send_bgName = StinkyQueue_GameIndex[StinkyQueue_GameName[bgName]];
				Send_bgID = bgID;
				if (bgName == StinkyQueue_NameGame[1]) then
					break;
				end
			end
			
		end
		StinkyQueue_SendAddonMessage("QStatus",Send_bgStatus);
		StinkyQueue_SendAddonMessage("QName",Send_bgName);
		StinkyQueue_SendAddonMessage("GameNumb",Send_bgID);
	
	elseif (event == "BATTLEFIELDS_SHOW") then
		local bgName = GetBattlefieldInfo(); 
		StinkyQueue_ShowGroupQButton();
		StinkyQueue_ShowAVButton();
		StinkyQueue_SendAddonMessage("LastBG",StinkyQueue_GameName[bgName]);
	elseif (event == "CHAT_MSG_ADDON") then
		SQ_Debug("   -"..arg1)
		if (arg1== "StinkyQ") then
			SQ_Debug("       -"..arg3);
			if ((StinkyQueue_isInBG() and arg3 == "BATTLEGROUND") or (not StinkyQueue_isInBG() and arg3 ~= "BATTLEGROUND")) then
				local msgCount,msgTable = StinkyQueue_ParseMessage(arg2," ");
				if (msgCount == -1) then
					StinkyQueue_ErrorMessage("CHAT_MSG_ADDON, no command to process.",1);
					return(0);
				elseif (msgTable[1] == "Queue") then
					StinkyQueue_Queue(0);
				elseif (msgTable[1] == "LeaveQueue") then 
					StinkyQueue_LeaveQueue(-1,true)
				elseif (msgTable[1] == "SoloQ") then 
					if (msgCount ~= 2) then
						StinkyQueue_ErrorMessage("SoloQueue did not get enough information.  SendAddonMessage error!",1);
						return(0);
					else
						StinkyQueue_Queue(msgTable[2],msgTable[3])
						SQ_Debug(msgTable[2].." --- "..msgTable[3], true);
					end

				elseif (msgTable[1] == "QStatus") then 
					StinkyQueue_UpdateUser(arg4,msgTable[1],msgTable[2])
				elseif (msgTable[1] == "QName") then 
					StinkyQueue_UpdateUser(arg4,msgTable[1],msgTable[2])
				elseif (msgTable[1] == "GameNumb") then 
					StinkyQueue_UpdateUser(arg4,msgTable[1],msgTable[2])
				elseif (msgTable[1] == "VersionCheck") then
					StinkyQueue_SendAddonMessage("Version",StinkyQueue_Version,true);
				elseif (msgTable[1] == "Version") then
					StinkyQueue_UpdateUser(arg4,msgTable[1],msgTable[2])
				elseif (msgTable[1] == "LastBG") then 
					StinkyQueue_UpdateUser(arg4,msgTable[1],msgTable[2])
				else
					StinkyQueue_ErrorMessage("Unknown Chat_Msg_Addon Message!",1);
				end
			end
		end
	elseif (event == "PARTY_MEMBERS_CHANGED") then
		StinkyQueue_ShowGroupQButton();
		StinkyQueue_ShowAVButton();
		StinkyQueue_UpdatePartymembers();
	elseif (event == "ADDON_LOADED") then
		if (arg1 == "StinkyQueue2") then
			StinkyQueue_DoCheckBoxes();
		end
	
	end
end

function StinkyQueue_OnClick(arg)
	SQ_Debug(arg,1);
	if (arg == "StinkyQueue_AVButton") then
		StinkyQueue_ShowHideSQ();
	elseif (arg == "StinkyQueue_Frame_Queue") then
		StinkyQueue_SendAddonMessage("Queue",nil,true)
	elseif (arg == "StinkyQueue_Frame_LeaveQueue") then
		StinkyQueue_SendAddonMessage("LeaveQueue",-1,true)
	elseif (arg == "StinkyQueue_Frame_SoloQueue") then
		StinkyQueue_SoloQueue();
	elseif (arg == "StinkyQueue_Frame_GroupQueue") then
		StinkyQueue_GroupQueue();
	elseif (arg == "StinkyQueue_Frame_Version") then
		StinkyQueue_SendAddonMessage("VersionCheck",nil,true);
	elseif (arg == "StinkyQueue_Scrollbar_Refresh") then
		StinkyQueue_UpdatePartymembers();
	elseif (arg == "StinkyQueue_Frame_RaidWarning") then
		StinkyQueue_Options.RaidWarning = StinkyQueue_GetCheckStatus(StinkyQueue_Frame_RaidWarning);
	elseif (arg == "StinkyQueue_Frame_Raid") then
		StinkyQueue_Options.Raid = StinkyQueue_GetCheckStatus(StinkyQueue_Frame_Raid);
	elseif (arg == "StinkyQueue_Frame_EnableSQ") then
		StinkyQueue_Options.Enabled =StinkyQueue_GetCheckStatus(StinkyQueue_Frame_EnableSQ);
		StinkyQueue_EnableDisable();
	end
		
end

function StinkyQueue_EnableDisable()
	local this=StinkyQueue_General;
	if (StinkyQueue_Options.Enabled) then
		this:RegisterEvent("CHAT_MSG_ADDON");
		this:RegisterEvent("BATTLEFIELDS_SHOW");
		this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
		this:RegisterEvent("PARTY_MEMBERS_CHANGED");
		this:RegisterEvent("ADDON_LOADED");
		return true;
	else
		this:UnregisterEvent("CHAT_MSG_ADDON");
		this:UnregisterEvent("BATTLEFIELDS_SHOW");
		this:UnregisterEvent("UPDATE_BATTLEFIELD_STATUS");
		this:UnregisterEvent("PARTY_MEMBERS_CHANGED");
		this:UnregisterEvent("ADDON_LOADED");
		return false;
	end
		
end
function StinkyQueue_ScrollFrameInit()
	if (false) then
		for i=1,45 do
			StinkyQueue_PartyMembers[i]= {};
			StinkyQueue_PartyMembers[i].Name=strrep(strchar(random(97,122)),random(12));
			StinkyQueue_PartyMembers[i].QStatus=random(5);
			StinkyQueue_PartyMembers[i].QName=random(3);
			StinkyQueue_PartyMembers[i].GameNumb=random(100,200);
			StinkyQueue_PartyMembers[i].Version="2."..random(10,30).."."..random(100,999);
			if (random(0,1)==1) then
				StinkyQueue_PartyMembers[i].LastBG=1;
			else
				StinkyQueue_PartyMembers[i].LastBG=0;
			end
		end
		StinkyQueue_MainScrollbar:Show();
		sort(StinkyQueue_PartyMembers, 
		function(a,b) local toReturn=true; if (a.GameNumb == b.GameNumb) then toReturn = (a.Name > b.Name);else toReturn = (a.GameNumb > b.GameNumb); end return toReturn; end);
	else
			StinkyQueue_PartyMembers[1]= {};
			StinkyQueue_PartyMembers[1].Name="";
			StinkyQueue_PartyMembers[1].QStatus="";
			StinkyQueue_PartyMembers[1].QName="";
			StinkyQueue_PartyMembers[1].GameNumb="";
			StinkyQueue_PartyMembers[1].Version="";
			StinkyQueue_PartyMembers[1].LastBG=5;
			StinkyQueue_UpdatePartymembers(true);
			StinkyQueue_ScrollUpdate()
	end
end

function StinkyQueue_VarsInit()
	StinkyQueue_Options={};
	StinkyQueue_Options["Raid"] = false;
	StinkyQueue_Options["RaidWarning"] = true;
	StinkyQueue_Options["Enabled"] = true;
	StinkyQueue_Options["Version"] = StinkyQueue_Version;
end


function StinkyQueue_DoCheckBoxes()
	getglobal(("StinkyQueue_Frame".."_RaidWarning")):SetChecked(StinkyQueue_Options.RaidWarning);
	getglobal(("StinkyQueue_Frame".."_Raid")):SetChecked(StinkyQueue_Options.Raid);
	getglobal(("StinkyQueue_Frame".."_EnableSQ")):SetChecked(StinkyQueue_Options.Enabled);
	StinkyQueue_ShowGroupQButton();
end

function StinkyQueue_DoTexts()
	getglobal(((this:GetName()).."_Version")):SetText(StinkyQueue_Options.Version);
end

--
--	StinkyQueue Actual Queuing Functions
--

function StinkyQueue_Queue(bgNumb,frameID,noSpam)
	if (StinkyQueue_BGWindow_Active(true)) then
		bgNumb = tonumber(bgNumb);
		frameID = tonumber(frameID);
		if (frameID == nil) then
			frameID = -1;
		end
		StinkyQueue_LeaveQueue(bgNumb,true,nil,true);
		StinkyQueue_ShowList();
		if (GetBattlefieldInstanceInfo(frameID) == bgNumb) then
			JoinBattlefield(frameID);
		else
			-- frameID = StinkyQueue_indexForID(bgNumb)
			for i=1, GetNumBattlefields() do
				local bgStatus, bgName, bgID = GetBattlefieldStatus(i);
				if (bgID ~= bgNumb and bgName == GetBattlefieldInfo() and bgStatus ~= "active") then
						JoinBattlefield(i);			
				end
			end


		end
	end
end

function StinkyQueue_LeaveQueue(bgNumb,force,forceAll,noSpam)
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local bgStatus, bgName, bgID = GetBattlefieldStatus(i);
		if ((bgID ~= bgNumb and bgName == GetBattlefieldInfo() and (bgStatus ~= "active" or force)) or forceAll) then
			ShowBattlefieldList(i)
			AcceptBattlefieldPort(i,nil);
		end
	end
end

function StinkyQueue_ShowList()
	JoinBattlefield(0);
	BattlefieldFrame:Show();
	for i=1, MAX_BATTLEFIELD_QUEUES do
		local bgStatus, bgName, bgID = GetBattlefieldStatus(i)
		if (bgName == GetBattlefieldInfo()) then
			ShowBattlefieldList(i)
		end
	end
end

function StinkyQueue_SoloQueue()
	if (StinkyQueue_BGWindow_Active(true)) then
		local BgFrame_RowID=0;
		if (StinkyQueue_Frame_SoloQueue:GetText() == "Solo Queue") then
			StinkyQueue_ShowList();
			StinkyQueue_Frame_SoloQueue:SetText("Send Selected BG");
		elseif (BattlefieldFrame:IsVisible()) then
			BgFrame_RowID = GetSelectedBattlefield();
			StinkyQueue_LeaveQueue(GetBattlefieldInstanceInfo(BgFrame_RowID),nil,nil,true);
			StinkyQueue_Frame_SoloQueue:SetText("Solo Queue");
			StinkyQueue_SendAddonMessage("SoloQ",GetBattlefieldInstanceInfo(BgFrame_RowID).." "..BgFrame_RowID,true)
		else
			BattlefieldFrame:Show();
		end
	end
end

function StinkyQueue_indexForID(bgNumb)
	for i=1, GetNumBattlefields() do
		if(GetBattlefieldInstanceInfo(i)==bgNumb) then
			return i;			
		end
	end

end
function StinkyQueue_GroupQueue(bgNumb)
	if (StinkyQueue_BGWindow_Active(true)) then
		if (bgNumb == nil) then
			bgNumb = 0;
		else
			bgNumb = tonumber(bgNumb);
			SQ_Debug(bgNumb);
			bgNumb = StinkyQueue_indexForID(bgNumb);
		end

		JoinBattlefield(bgNumb,1);
	end
end

--
--	StinkyQueue PartyMembers Table Functions
--


function StinkyQueue_BGColorCode(bgNumber)
	local colors = {};
     if (bgNumber==1) then
		colors.red=1;
		colors.green=1
		colors.blue=1;
		colors.opacity=1;
      	elseif (bgNumber==2) then
		colors.red=0;
		colors.green=1;
		colors.blue=0;
		colors.opacity=.5;
      	elseif (bgNumber==3) then
		colors.red=0;
		colors.green=0;
		colors.blue=1;
		colors.opacity=1;
      	elseif (bgNumber==4) then
		colors.red=1;
		colors.green=.0;
		colors.blue=0;
		colors.opacity=1;
      	elseif (bgNumber==5) then
		colors.red=1;
		colors.green=1;
		colors.blue=1;
		colors.opacity=.5;
      	else
		colors.red=1;
		colors.green=0;
		colors.blue=0;
		colors.opacity=.5;
      	end
      	return colors;

end

function StinkyQueue_UpdateUser(name,field,value)
	if ((not StinkyQueue_isRaid() and name ~= UnitName("player")) or StinkyQueue_isRaid()) then
		StinkyQueue_PartyMembers[StinkyQueue_RaidIndexTable[name]][field]=value;
		StinkyQueue_ScrollUpdate()
	end
	
end


function StinkyQueue_InitPartyMembersTable(table)
		table.QStatus = "";
		table.QName = "";
		table.GameNumb= "";
		table.Version = "";
		table.LastBG = 5;
end

function StinkyQueue_CopyPartyMembersTable(oldTable,newTable)
		newTable.QStatus = oldTable.Qstatus;
		newTable.QName = oldTable.QName;
		newTable.GameNumb = oldTable.GameNumb;
		newTable.Version = oldTable.Version;
		newTable.LastBG = oldTable.LastBG;
end


--
--	StinkyQueue GUI Functions
--


function StinkyQueue_ShowAVButton()
	if (GetBattlefieldInfo() == StinkyQueue_NameGame[1]) then
		StinkyQueue_AVButton:Show();
		
		if (StinkyQueue_isSolo()) then
			StinkyQueue_AVButton:Disable();
		else
			StinkyQueue_AVButton:Enable();
		end
	else
		StinkyQueue_AVButton:Hide();
	end
end

function StinkyQueue_BGWindow_Active(spam)
	local lastBGQueue = GetBattlefieldInfo();
	if (lastBGQueue == nil and spam) then
		StinkyQueue_ErrorMessage("This addon isn't magic.  You still have to talk to the BG Master you want to Queue for.",.9,.4,.2);
	end
	return (lastBGQueue~=nil);
end

function StinkyQueue_ShowGroupQButton()
	if (CanJoinBattlefieldAsGroup()==nil or StinkyQueue_isSolo() or (not IsPartyLeader() or not IsRaidLeader())) then
		StinkyQueue_Frame_GroupQueue:Disable();
	else
		StinkyQueue_Frame_GroupQueue:Enable();
	end
end

function StinkyQueue_ShowHideSQ()
	if (StinkyQueue_Frame:IsVisible()) then
		StinkyQueue_Frame:Hide();
	else
		StinkyQueue_Frame:Show();
	end
end

function StinkyQueue_UpdatePartymembers(force)
	local unitidName;
	local StinkyQueue_TableTemp={};
	local StinkyQueue_TempIndexTable = {};
	if (StinkyQueue_isRaid()) then
		unitidName="raid";
	else
		unitidName="party";
	end
	if ((StinkyQueue_PartyRaidCount ~= StinkyQueue_TotalRaidPartyMembers()) or force) then
		StinkyQueue_PartyRaidCount = StinkyQueue_TotalRaidPartyMembers();
		for i=1,StinkyQueue_PartyRaidCount, 1 do
			name=UnitName(unitidName..i);
			StinkyQueue_TableTemp[i]={};
			StinkyQueue_TableTemp[i].Name=name;
			if (StinkyQueue_PartyMembers[StinkyQueue_RaidIndexTable[name]]==nil) then
				StinkyQueue_InitPartyMembersTable(StinkyQueue_TableTemp[i])
			else
				StinkyQueue_CopyPartyMembersTable(StinkyQueue_PartyMembers[StinkyQueue_RaidIndexTable[name]],StinkyQueue_TableTemp[i])
			end
			StinkyQueue_TempIndexTable[name]=i;			
		end
		StinkyQueue_PartyMembers[StinkyQueue_PartyRaidCount+1]=nil;
		StinkyQueue_PartyMembers=StinkyQueue_TableTemp;
		StinkyQueue_RaidIndexTable=StinkyQueue_TempIndexTable;
	end
	StinkyQueue_ScrollUpdate();
end

function StinkyQueue_ScrollUpdate()
local PartyMemberElements=getn(StinkyQueue_PartyMembers);
local nameColors,gameColors;
  local line; -- 1 through 15 of our window to scroll
  local emptyTable = {Name="",QStatus="",QName="",GameNumb="",Version="",LastBG=5}
  local tableSwitcher = {};
  local lineplusoffset; -- an index into our data calculated from the scroll offset
  FauxScrollFrame_Update(StinkyQueue_MainScrollbar,PartyMemberElements,15,16);
  for line=1,15 do

    lineplusoffset = line + FauxScrollFrame_GetOffset(StinkyQueue_MainScrollbar);
    if (lineplusoffset <= 45) then
    	if (line > PartyMemberElements) then
    		tableSwitcher = emptyTable;
    	else
    		tableSwitcher = StinkyQueue_PartyMembers[lineplusoffset];
    	end
      getglobal("StinkyQueueScroll_M_Name"..line.."_Text"):SetText(tableSwitcher.Name);
      getglobal("StinkyQueueScroll_M_QStatus"..line.."_Text"):SetText(tableSwitcher.QStatus);
      getglobal("StinkyQueueScroll_M_QName"..line.."_Text"):SetText(tableSwitcher.QName);
      getglobal("StinkyQueueScroll_M_GameNumb"..line.."_Text"):SetText(tableSwitcher.GameNumb);
      getglobal("StinkyQueueScroll_M_Version"..line.."_Text"):SetText(tableSwitcher.Version);
      nameColors = StinkyQueue_BGColorCode(tonumber(tableSwitcher.LastBG));
      gameColors = StinkyQueue_BGColorCode(tonumber(StinkyQueue_IndexGame[tableSwitcher.QName]));
      	getglobal("StinkyQueueScroll_M_Name"..line.."_Text"):SetTextColor(nameColors.red,nameColors.green,nameColors.blue,nameColors.opacity);
      	getglobal("StinkyQueueScroll_M_QName"..line.."_Text"):SetTextColor(gameColors.red,gameColors.green,gameColors.blue,gameColors.opacity);
      getglobal("StinkyQueueScroll_M_Name"..line):Show();
    else
      getglobal("StinkyQueueScroll_M_Name"..line):Hide();
    end
  end
end


--
--	StinkyQueue Helper Functions
--

function StinkyQueue_isInBG()
	for i=1, MAX_BATTLEFIELD_QUEUES, 1 do
		local bgStatus = GetBattlefieldStatus(i);
		if (bgStatus == "active") then
			return true;
		end

	end
	return false;

end


function StinkyQueue_GetCheckStatus(frame)
	local toReturn = false;
	if (frame:GetChecked() ~= nil) then
		toReturn = true;
	end
	return toReturn;
end

function StinkyQueue_SendAddonMessage(message,value,force)
	local toSend;
	local sendValue="";
	local hasRights = StinkyQueue_hasRights();
	local bgName = GetBattlefieldInfo();
	if (bgName == nil) then
		bgName = 6;
	end
	
	if (message == "Queue") then
		StinkyQueue_RaidSpam("Initial Queue");
	elseif (message == "LeaveQueue") then
		StinkyQueue_RaidSpam("Leaving Queue in "..bgName);
	elseif (message == "SoloQ") then
		local parsedCount, parsedTable = StinkyQueue_ParseMessage(value," ");
		StinkyQueue_RaidSpam("SoloQueue for: "..parsedTable[1].." in "..bgName);
	else
		if (StinkyQueue_hasRights()) then
			hasRights = true;
		end
	end
	if ((StinkyQueue_SelfData[message] ~= value) or force) then
		if (StinkyQueue_isInBG()) then
			toSend = "BATTLEGROUND";
		elseif (StinkyQueue_isRaid()) then
			toSend = "RAID";
		else
			toSend = "PARTY";
		end
		if (value ~= nil) then
			sendValue = " "..value;
		end
		if (hasRights) then
			SendAddonMessage("StinkyQ", message..sendValue, toSend );
			StinkyQueue_SelfData[message]=value;
		end
	end

end

function StinkyQueue_ParseMessage(message,split)
	 local toReturn={};
	 local totCount=0;
	 local a,b,c,d,e,f,g;
	 if (split == nil) then
	 	split = " ";
	 end
	 a,b,c,d,e,f,g = strsplit(split, message)
	 if (a~=nil) then
	 	tinsert(toReturn, a)
	 end
	 if (b~=nil) then
	 	tinsert(toReturn, b)
	 end
	 if (c~=nil) then
	 	tinsert(toReturn, c)
	 end
	 if (d~=nil) then
	 	tinsert(toReturn, d)
	 end
	 if (e~=nil) then
	 	tinsert(toReturn, e)
	 end
	 if (f~=nil) then
	 	tinsert(toReturn, f)
	 end
	 if (g~=nil) then
	 	tinsert(toReturn, g)
	 end
	 return getn(toReturn)-1,toReturn;
end
function StinkyQueue_isRaid()
	return (GetNumRaidMembers()>0);
end

function StinkyQueue_isSolo()
	return((GetNumPartyMembers()==0) and (GetNumRaidMembers()==0));
end

function StinkyQueue_hasRights()
	return (IsRaidOfficer() or IsRaidLeader() or IsPartyLeader())
end

function StinkyQueue_TotalRaidPartyMembers()
	local toReturn=0;
	if (GetNumRaidMembers()>0) then
		toReturn = GetNumRaidMembers();
	elseif (GetNumPartyMembers()>0) then
		toReturn = GetNumPartyMembers();
	end
	return toReturn;
end

function SQ_Debug(msg,error,trace)
	if (SQ_debugMode) then
	
		if (msg == nil) then
			msg = "nil";
		end;
		if (type(msg) == "boolean") then
			if (msg) then
				msg = "Bool: True";
			else
				msg = "Bool: False";
			end
		end
		if (error) then
			DEFAULT_CHAT_FRAME:AddMessage(type(msg).." : ["..msg.."]",1.0, 0.35, 0.0);
		else
			DEFAULT_CHAT_FRAME:AddMessage(type(msg).." : ["..msg.."]",1.0, 1.0, 0.75);
		end
		if (trace) then
			DEFAULT_CHAT_FRAME:AddMessage(debugstack());
		end
	end
end

function StinkyQueue_ErrorMessage(message,red,green,blue)
	DEFAULT_CHAT_FRAME:AddMessage("StinkyQueue - "..message,red, green, blue);
end
	
function StinkyQueue_RaidSpam(message)
	local doRaidWarning = StinkyQueue_Options.RaidWarning;
	local doRaid = StinkyQueue_Options.Raid;
	local raidText = "RAID";
	message = "StinkyQueue: "..message;
	if (StinkyQueue_hasRights()) then
		if (not StinkyQueue_isRaid()) then
			if (doRaidWarning) then
				doRaidWarning = false;
				doRaid = true;
			end
			raidText = "PARTY";
		end
		if (doRaidWarning) then
			SendChatMessage(message,"RAID_WARNING");
		end

		if (doRaid) then
			SendChatMessage(message,raidText);
		end
	else
		SendChatMessage("!HaXXed! - "..message,raidText);
	end
end


--
--	StinkyQueue Slash Command Dealings
--

function StinkyQueue_SlashCommands(msg)
	local msgCount,msgTable = StinkyQueue_ParseMessage(strlower(msg));
	local msgRed = 1;
	local msgGreen = 1;
	local msgBlue = .75;
	if (msgTable[1] == "") then
		StinkyQueue_ShowHideSQ();	
	elseif (msgTable[1] == "help" or msgTable[1] == "h" or msgTable[1] == "?") then
		StinkyQueue_ErrorMessage("                   Kazthok's StinkyQueue Help",msgRed,msgGreen*.5,msgBlue);	
		StinkyQueue_ErrorMessage("/sq                         - Show/Hide the SQ GUI window.",msgRed,msgGreen,msgBlue);		
		StinkyQueue_ErrorMessage("/sq help          [h][?] - This Help",msgRed,msgGreen,msgBlue);		
		StinkyQueue_ErrorMessage("/sq queue           [q] - Force everone to 'click' [Join Battleground] at the same time.",msgRed,msgGreen,msgBlue);
		StinkyQueue_ErrorMessage("/sq leavequeue    [lq]- Force everyone to Leave Queue for the Queuer's last window",msgRed,msgGreen,msgBlue);
		StinkyQueue_ErrorMessage("/sq soloqueue #  [sq]- Force those with out BG# to leave theirs and single queue for it.",msgRed,msgGreen,msgBlue);
		StinkyQueue_ErrorMessage("/sq groupqueue  # [gq]- Queues as a group what your last BG window was.",msgRed,msgGreen,msgBlue);
		StinkyQueue_ErrorMessage("/sq disable          [d] - Toggles if SQ is Enabled or Disabled",msgRed,msgGreen,msgBlue);
		StinkyQueue_ErrorMessage("/sq test              [t] - Test to see if your BG window AV last.",msgRed,msgGreen,msgBlue);
		StinkyQueue_ErrorMessage("Slash Commands:            /stinkyqueue; /stinkyq; /sq; /stinkpalm;",msgRed,msgGreen,msgBlue);
	elseif (msgTable[1] == "queue" or msgTable[1] == "q") then
		StinkyQueue_SendAddonMessage("Queue",nil,true)
	elseif (msgTable[1] == "leavequeue" or msgTable[1] == "lq") then
		StinkyQueue_SendAddonMessage("LeaveQueue",-1,true)
	elseif (msgTable[1] == "soloqueue" or msgTable[1] == "sq") then
		StinkyQueue_SoloQueue();
	elseif (msgTable[1] == "groupqueue" or msgTable[1] == "gq") then
		StinkyQueue_GroupQueue(msgTable[2]);
	elseif (msgTable[1] == "disable" or msgTable[1] == "d") then
		StinkyQueue_Options.Enabled = StinkyQueue_EnableDisable();
	elseif (msgTable[1] == "test" or msgTable[1] == "t") then
		
	elseif (msgTable[1] == "" or msgTable[1] == "") then
	
	elseif (msgTable[1] == "" or msgTable[1] == "") then
	
	elseif (msgTable[1] == "" or msgTable[1] == "") then
	
	elseif (msgTable[1] == "" or msgTable[1] == "") then
	
	elseif (msgTable[1] == "" or msgTable[1] == "") then
	
	end
end

	SLASH_STINKYQUEUE1 = "/stinkyqueue";
	SLASH_STINKYQUEUE2 = "/stinkyq";
	SLASH_STINKYQUEUE3 = "/sq";
	SLASH_STINKYQUEUE4 = "/stinkpalm";
SlashCmdList["STINKYQUEUE"] = StinkyQueue_SlashCommands;

	-- Special thanks to:

-- Animation 	- SQ Party sitting while I debug functions
-- Santi 	- Staying up until 7AM one morning as I spammed him with stuff I wanted him to click.
